/*
 * Semantic Similarity API
 *
 * This API computes the simlarity of RDF entities
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.SemanticSimilarity.Core.Client.OpenAPIDateConverter;

namespace Coscine.SemanticSimilarity.Core.Model
{
    /// <summary>
    /// SimilarityMatrix
    /// </summary>
    [DataContract(Name = "SimilarityMatrix")]
    public partial class SimilarityMatrix : IEquatable<SimilarityMatrix>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SimilarityMatrix" /> class.
        /// </summary>
        /// <param name="graphDistances">graphDistances.</param>
        /// <param name="fileDistances">fileDistances.</param>
        public SimilarityMatrix(List<List<decimal>> graphDistances = default(List<List<decimal>>), List<List<decimal>> fileDistances = default(List<List<decimal>>))
        {
            this.GraphDistances = graphDistances;
            this.FileDistances = fileDistances;
        }

        /// <summary>
        /// Gets or Sets GraphDistances
        /// </summary>
        [DataMember(Name = "graphDistances", EmitDefaultValue = false)]
        public List<List<decimal>> GraphDistances { get; set; }

        /// <summary>
        /// Gets or Sets FileDistances
        /// </summary>
        [DataMember(Name = "fileDistances", EmitDefaultValue = false)]
        public List<List<decimal>> FileDistances { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SimilarityMatrix {\n");
            sb.Append("  GraphDistances: ").Append(GraphDistances).Append("\n");
            sb.Append("  FileDistances: ").Append(FileDistances).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SimilarityMatrix);
        }

        /// <summary>
        /// Returns true if SimilarityMatrix instances are equal
        /// </summary>
        /// <param name="input">Instance of SimilarityMatrix to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SimilarityMatrix input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.GraphDistances == input.GraphDistances ||
                    this.GraphDistances != null &&
                    input.GraphDistances != null &&
                    this.GraphDistances.SequenceEqual(input.GraphDistances)
                ) && 
                (
                    this.FileDistances == input.FileDistances ||
                    this.FileDistances != null &&
                    input.FileDistances != null &&
                    this.FileDistances.SequenceEqual(input.FileDistances)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.GraphDistances != null)
                {
                    hashCode = (hashCode * 59) + this.GraphDistances.GetHashCode();
                }
                if (this.FileDistances != null)
                {
                    hashCode = (hashCode * 59) + this.FileDistances.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
